package cn.ecpark.service.usergw.utils;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.context.SpringBootTest.WebEnvironment;
import org.springframework.boot.web.server.LocalServerPort;
import org.springframework.cloud.gateway.filter.factory.SetRequestHeaderGatewayFilterFactory;
import org.springframework.cloud.gateway.filter.factory.SetStatusGatewayFilterFactory;
import org.springframework.test.context.TestPropertySource;
import org.springframework.test.context.junit4.SpringRunner;

import cn.ecpark.service.usergw.App;
import reactor.core.publisher.Mono;
import reactor.netty.http.client.HttpClient;
import reactor.netty.http.client.HttpClient.ResponseReceiver;
import reactor.netty.http.client.HttpClientResponse;

// TODO: 添加附加Dubbo Service for Test启动进程
@SpringBootTest(classes = App.class, webEnvironment = WebEnvironment.RANDOM_PORT)
@RunWith(SpringRunner.class)
@TestPropertySource(locations = { "application2.properties" })
public class TestHttp2DubboConfig2 {

    @LocalServerPort
    private int serverPort;

    @Test
    public void Test2RequestHttp2DubboSetHeader() {

        // Test Base Url
        HttpClient client = HttpClient.create();
        ResponseReceiver<?> receiver;
        String content;
        // receiver = client.baseUrl("http://localhost:" + serverPort + "/dubbo/hello").headers(
        //         h -> h.set("method", "Say").add("param-types", "java.lang.String").add("params", "Test-MyHttp2dubbo"))
        //         .get();

        // HttpClientResponse resp = receiver.response().block();
        // Assert.assertNotNull(resp);

        // content = receiver.responseContent().asString().blockLast();
        // Assert.assertEquals(resp.status().code(), 200);
        // Assert.assertNotNull(content);
        // Assert.assertEquals(content, "SetHeader");

        receiver = client.baseUrl("http://localhost:" + serverPort + "/dubbo/hello")
                .headers(h -> h.set("method", "Hello")).get();
        HttpClientResponse response = receiver.response().block();

        Assert.assertNotNull(response); 
        // Assert.assertEquals(response.status().code(), 404);
        
        int code = response.status().code();
        content = receiver.responseContent().asString().blockLast();
        Assert.assertNull(content);


    }

 
}